/**
 * Autogenerated by Avro
 *
 * DO NOT EDIT DIRECTLY
 */
package org.datastream.khodza.model.avro.p_presentronik_cache_kelas_sesi_perkuliahan;

import org.apache.avro.specific.SpecificData;

@SuppressWarnings("all")
@org.apache.avro.specific.AvroGenerated
public class Value extends org.apache.avro.specific.SpecificRecordBase implements org.apache.avro.specific.SpecificRecord {
  private static final long serialVersionUID = 5690316612991783941L;
  public static final org.apache.avro.Schema SCHEMA$ = new org.apache.avro.Schema.Parser().parse("{\"type\":\"record\",\"name\":\"Value\",\"namespace\":\"org.datastream.khodza.model.avro.p_presentronik_cache_kelas_sesi_perkuliahan\",\"fields\":[{\"name\":\"id_kuliah\",\"type\":\"long\"},{\"name\":\"kd_kelas\",\"type\":\"string\"},{\"name\":\"tanggal\",\"type\":{\"type\":\"int\",\"connect.version\":1,\"connect.name\":\"io.debezium.time.Date\"}},{\"name\":\"wkt_mulai\",\"type\":{\"type\":\"long\",\"connect.version\":1,\"connect.name\":\"io.debezium.time.MicroTimestamp\"}},{\"name\":\"wkt_selesai\",\"type\":{\"type\":\"long\",\"connect.version\":1,\"connect.name\":\"io.debezium.time.MicroTimestamp\"}},{\"name\":\"ts_update\",\"type\":{\"type\":\"long\",\"connect.version\":1,\"connect.name\":\"io.debezium.time.MicroTimestamp\"}}],\"connect.name\":\"p_presentronik.presentronik.cache_kelas_sesi_perkuliahan.Value\"}");
  public static org.apache.avro.Schema getClassSchema() { return SCHEMA$; }
  @Deprecated public long id_kuliah;
  @Deprecated public java.lang.CharSequence kd_kelas;
  @Deprecated public int tanggal;
  @Deprecated public long wkt_mulai;
  @Deprecated public long wkt_selesai;
  @Deprecated public long ts_update;

  /**
   * Default constructor.  Note that this does not initialize fields
   * to their default values from the schema.  If that is desired then
   * one should use <code>newBuilder()</code>.
   */
  public Value() {}

  /**
   * All-args constructor.
   * @param id_kuliah The new value for id_kuliah
   * @param kd_kelas The new value for kd_kelas
   * @param tanggal The new value for tanggal
   * @param wkt_mulai The new value for wkt_mulai
   * @param wkt_selesai The new value for wkt_selesai
   * @param ts_update The new value for ts_update
   */
  public Value(java.lang.Long id_kuliah, java.lang.CharSequence kd_kelas, java.lang.Integer tanggal, java.lang.Long wkt_mulai, java.lang.Long wkt_selesai, java.lang.Long ts_update) {
    this.id_kuliah = id_kuliah;
    this.kd_kelas = kd_kelas;
    this.tanggal = tanggal;
    this.wkt_mulai = wkt_mulai;
    this.wkt_selesai = wkt_selesai;
    this.ts_update = ts_update;
  }

  public org.apache.avro.Schema getSchema() { return SCHEMA$; }
  // Used by DatumWriter.  Applications should not call.
  public java.lang.Object get(int field$) {
    switch (field$) {
    case 0: return id_kuliah;
    case 1: return kd_kelas;
    case 2: return tanggal;
    case 3: return wkt_mulai;
    case 4: return wkt_selesai;
    case 5: return ts_update;
    default: throw new org.apache.avro.AvroRuntimeException("Bad index");
    }
  }

  // Used by DatumReader.  Applications should not call.
  @SuppressWarnings(value="unchecked")
  public void put(int field$, java.lang.Object value$) {
    switch (field$) {
    case 0: id_kuliah = (java.lang.Long)value$; break;
    case 1: kd_kelas = (java.lang.CharSequence)value$; break;
    case 2: tanggal = (java.lang.Integer)value$; break;
    case 3: wkt_mulai = (java.lang.Long)value$; break;
    case 4: wkt_selesai = (java.lang.Long)value$; break;
    case 5: ts_update = (java.lang.Long)value$; break;
    default: throw new org.apache.avro.AvroRuntimeException("Bad index");
    }
  }

  /**
   * Gets the value of the 'id_kuliah' field.
   * @return The value of the 'id_kuliah' field.
   */
  public java.lang.Long getIdKuliah() {
    return id_kuliah;
  }

  /**
   * Sets the value of the 'id_kuliah' field.
   * @param value the value to set.
   */
  public void setIdKuliah(java.lang.Long value) {
    this.id_kuliah = value;
  }

  /**
   * Gets the value of the 'kd_kelas' field.
   * @return The value of the 'kd_kelas' field.
   */
  public java.lang.CharSequence getKdKelas() {
    return kd_kelas;
  }

  /**
   * Sets the value of the 'kd_kelas' field.
   * @param value the value to set.
   */
  public void setKdKelas(java.lang.CharSequence value) {
    this.kd_kelas = value;
  }

  /**
   * Gets the value of the 'tanggal' field.
   * @return The value of the 'tanggal' field.
   */
  public java.lang.Integer getTanggal() {
    return tanggal;
  }

  /**
   * Sets the value of the 'tanggal' field.
   * @param value the value to set.
   */
  public void setTanggal(java.lang.Integer value) {
    this.tanggal = value;
  }

  /**
   * Gets the value of the 'wkt_mulai' field.
   * @return The value of the 'wkt_mulai' field.
   */
  public java.lang.Long getWktMulai() {
    return wkt_mulai;
  }

  /**
   * Sets the value of the 'wkt_mulai' field.
   * @param value the value to set.
   */
  public void setWktMulai(java.lang.Long value) {
    this.wkt_mulai = value;
  }

  /**
   * Gets the value of the 'wkt_selesai' field.
   * @return The value of the 'wkt_selesai' field.
   */
  public java.lang.Long getWktSelesai() {
    return wkt_selesai;
  }

  /**
   * Sets the value of the 'wkt_selesai' field.
   * @param value the value to set.
   */
  public void setWktSelesai(java.lang.Long value) {
    this.wkt_selesai = value;
  }

  /**
   * Gets the value of the 'ts_update' field.
   * @return The value of the 'ts_update' field.
   */
  public java.lang.Long getTsUpdate() {
    return ts_update;
  }

  /**
   * Sets the value of the 'ts_update' field.
   * @param value the value to set.
   */
  public void setTsUpdate(java.lang.Long value) {
    this.ts_update = value;
  }

  /**
   * Creates a new Value RecordBuilder.
   * @return A new Value RecordBuilder
   */
  public static org.datastream.khodza.model.avro.p_presentronik_cache_kelas_sesi_perkuliahan.Value.Builder newBuilder() {
    return new org.datastream.khodza.model.avro.p_presentronik_cache_kelas_sesi_perkuliahan.Value.Builder();
  }

  /**
   * Creates a new Value RecordBuilder by copying an existing Builder.
   * @param other The existing builder to copy.
   * @return A new Value RecordBuilder
   */
  public static org.datastream.khodza.model.avro.p_presentronik_cache_kelas_sesi_perkuliahan.Value.Builder newBuilder(org.datastream.khodza.model.avro.p_presentronik_cache_kelas_sesi_perkuliahan.Value.Builder other) {
    return new org.datastream.khodza.model.avro.p_presentronik_cache_kelas_sesi_perkuliahan.Value.Builder(other);
  }

  /**
   * Creates a new Value RecordBuilder by copying an existing Value instance.
   * @param other The existing instance to copy.
   * @return A new Value RecordBuilder
   */
  public static org.datastream.khodza.model.avro.p_presentronik_cache_kelas_sesi_perkuliahan.Value.Builder newBuilder(org.datastream.khodza.model.avro.p_presentronik_cache_kelas_sesi_perkuliahan.Value other) {
    return new org.datastream.khodza.model.avro.p_presentronik_cache_kelas_sesi_perkuliahan.Value.Builder(other);
  }

  /**
   * RecordBuilder for Value instances.
   */
  public static class Builder extends org.apache.avro.specific.SpecificRecordBuilderBase<Value>
    implements org.apache.avro.data.RecordBuilder<Value> {

    private long id_kuliah;
    private java.lang.CharSequence kd_kelas;
    private int tanggal;
    private long wkt_mulai;
    private long wkt_selesai;
    private long ts_update;

    /** Creates a new Builder */
    private Builder() {
      super(SCHEMA$);
    }

    /**
     * Creates a Builder by copying an existing Builder.
     * @param other The existing Builder to copy.
     */
    private Builder(org.datastream.khodza.model.avro.p_presentronik_cache_kelas_sesi_perkuliahan.Value.Builder other) {
      super(other);
      if (isValidValue(fields()[0], other.id_kuliah)) {
        this.id_kuliah = data().deepCopy(fields()[0].schema(), other.id_kuliah);
        fieldSetFlags()[0] = true;
      }
      if (isValidValue(fields()[1], other.kd_kelas)) {
        this.kd_kelas = data().deepCopy(fields()[1].schema(), other.kd_kelas);
        fieldSetFlags()[1] = true;
      }
      if (isValidValue(fields()[2], other.tanggal)) {
        this.tanggal = data().deepCopy(fields()[2].schema(), other.tanggal);
        fieldSetFlags()[2] = true;
      }
      if (isValidValue(fields()[3], other.wkt_mulai)) {
        this.wkt_mulai = data().deepCopy(fields()[3].schema(), other.wkt_mulai);
        fieldSetFlags()[3] = true;
      }
      if (isValidValue(fields()[4], other.wkt_selesai)) {
        this.wkt_selesai = data().deepCopy(fields()[4].schema(), other.wkt_selesai);
        fieldSetFlags()[4] = true;
      }
      if (isValidValue(fields()[5], other.ts_update)) {
        this.ts_update = data().deepCopy(fields()[5].schema(), other.ts_update);
        fieldSetFlags()[5] = true;
      }
    }

    /**
     * Creates a Builder by copying an existing Value instance
     * @param other The existing instance to copy.
     */
    private Builder(org.datastream.khodza.model.avro.p_presentronik_cache_kelas_sesi_perkuliahan.Value other) {
            super(SCHEMA$);
      if (isValidValue(fields()[0], other.id_kuliah)) {
        this.id_kuliah = data().deepCopy(fields()[0].schema(), other.id_kuliah);
        fieldSetFlags()[0] = true;
      }
      if (isValidValue(fields()[1], other.kd_kelas)) {
        this.kd_kelas = data().deepCopy(fields()[1].schema(), other.kd_kelas);
        fieldSetFlags()[1] = true;
      }
      if (isValidValue(fields()[2], other.tanggal)) {
        this.tanggal = data().deepCopy(fields()[2].schema(), other.tanggal);
        fieldSetFlags()[2] = true;
      }
      if (isValidValue(fields()[3], other.wkt_mulai)) {
        this.wkt_mulai = data().deepCopy(fields()[3].schema(), other.wkt_mulai);
        fieldSetFlags()[3] = true;
      }
      if (isValidValue(fields()[4], other.wkt_selesai)) {
        this.wkt_selesai = data().deepCopy(fields()[4].schema(), other.wkt_selesai);
        fieldSetFlags()[4] = true;
      }
      if (isValidValue(fields()[5], other.ts_update)) {
        this.ts_update = data().deepCopy(fields()[5].schema(), other.ts_update);
        fieldSetFlags()[5] = true;
      }
    }

    /**
      * Gets the value of the 'id_kuliah' field.
      * @return The value.
      */
    public java.lang.Long getIdKuliah() {
      return id_kuliah;
    }

    /**
      * Sets the value of the 'id_kuliah' field.
      * @param value The value of 'id_kuliah'.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_cache_kelas_sesi_perkuliahan.Value.Builder setIdKuliah(long value) {
      validate(fields()[0], value);
      this.id_kuliah = value;
      fieldSetFlags()[0] = true;
      return this;
    }

    /**
      * Checks whether the 'id_kuliah' field has been set.
      * @return True if the 'id_kuliah' field has been set, false otherwise.
      */
    public boolean hasIdKuliah() {
      return fieldSetFlags()[0];
    }


    /**
      * Clears the value of the 'id_kuliah' field.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_cache_kelas_sesi_perkuliahan.Value.Builder clearIdKuliah() {
      fieldSetFlags()[0] = false;
      return this;
    }

    /**
      * Gets the value of the 'kd_kelas' field.
      * @return The value.
      */
    public java.lang.CharSequence getKdKelas() {
      return kd_kelas;
    }

    /**
      * Sets the value of the 'kd_kelas' field.
      * @param value The value of 'kd_kelas'.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_cache_kelas_sesi_perkuliahan.Value.Builder setKdKelas(java.lang.CharSequence value) {
      validate(fields()[1], value);
      this.kd_kelas = value;
      fieldSetFlags()[1] = true;
      return this;
    }

    /**
      * Checks whether the 'kd_kelas' field has been set.
      * @return True if the 'kd_kelas' field has been set, false otherwise.
      */
    public boolean hasKdKelas() {
      return fieldSetFlags()[1];
    }


    /**
      * Clears the value of the 'kd_kelas' field.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_cache_kelas_sesi_perkuliahan.Value.Builder clearKdKelas() {
      kd_kelas = null;
      fieldSetFlags()[1] = false;
      return this;
    }

    /**
      * Gets the value of the 'tanggal' field.
      * @return The value.
      */
    public java.lang.Integer getTanggal() {
      return tanggal;
    }

    /**
      * Sets the value of the 'tanggal' field.
      * @param value The value of 'tanggal'.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_cache_kelas_sesi_perkuliahan.Value.Builder setTanggal(int value) {
      validate(fields()[2], value);
      this.tanggal = value;
      fieldSetFlags()[2] = true;
      return this;
    }

    /**
      * Checks whether the 'tanggal' field has been set.
      * @return True if the 'tanggal' field has been set, false otherwise.
      */
    public boolean hasTanggal() {
      return fieldSetFlags()[2];
    }


    /**
      * Clears the value of the 'tanggal' field.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_cache_kelas_sesi_perkuliahan.Value.Builder clearTanggal() {
      fieldSetFlags()[2] = false;
      return this;
    }

    /**
      * Gets the value of the 'wkt_mulai' field.
      * @return The value.
      */
    public java.lang.Long getWktMulai() {
      return wkt_mulai;
    }

    /**
      * Sets the value of the 'wkt_mulai' field.
      * @param value The value of 'wkt_mulai'.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_cache_kelas_sesi_perkuliahan.Value.Builder setWktMulai(long value) {
      validate(fields()[3], value);
      this.wkt_mulai = value;
      fieldSetFlags()[3] = true;
      return this;
    }

    /**
      * Checks whether the 'wkt_mulai' field has been set.
      * @return True if the 'wkt_mulai' field has been set, false otherwise.
      */
    public boolean hasWktMulai() {
      return fieldSetFlags()[3];
    }


    /**
      * Clears the value of the 'wkt_mulai' field.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_cache_kelas_sesi_perkuliahan.Value.Builder clearWktMulai() {
      fieldSetFlags()[3] = false;
      return this;
    }

    /**
      * Gets the value of the 'wkt_selesai' field.
      * @return The value.
      */
    public java.lang.Long getWktSelesai() {
      return wkt_selesai;
    }

    /**
      * Sets the value of the 'wkt_selesai' field.
      * @param value The value of 'wkt_selesai'.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_cache_kelas_sesi_perkuliahan.Value.Builder setWktSelesai(long value) {
      validate(fields()[4], value);
      this.wkt_selesai = value;
      fieldSetFlags()[4] = true;
      return this;
    }

    /**
      * Checks whether the 'wkt_selesai' field has been set.
      * @return True if the 'wkt_selesai' field has been set, false otherwise.
      */
    public boolean hasWktSelesai() {
      return fieldSetFlags()[4];
    }


    /**
      * Clears the value of the 'wkt_selesai' field.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_cache_kelas_sesi_perkuliahan.Value.Builder clearWktSelesai() {
      fieldSetFlags()[4] = false;
      return this;
    }

    /**
      * Gets the value of the 'ts_update' field.
      * @return The value.
      */
    public java.lang.Long getTsUpdate() {
      return ts_update;
    }

    /**
      * Sets the value of the 'ts_update' field.
      * @param value The value of 'ts_update'.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_cache_kelas_sesi_perkuliahan.Value.Builder setTsUpdate(long value) {
      validate(fields()[5], value);
      this.ts_update = value;
      fieldSetFlags()[5] = true;
      return this;
    }

    /**
      * Checks whether the 'ts_update' field has been set.
      * @return True if the 'ts_update' field has been set, false otherwise.
      */
    public boolean hasTsUpdate() {
      return fieldSetFlags()[5];
    }


    /**
      * Clears the value of the 'ts_update' field.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_cache_kelas_sesi_perkuliahan.Value.Builder clearTsUpdate() {
      fieldSetFlags()[5] = false;
      return this;
    }

    @Override
    public Value build() {
      try {
        Value record = new Value();
        record.id_kuliah = fieldSetFlags()[0] ? this.id_kuliah : (java.lang.Long) defaultValue(fields()[0]);
        record.kd_kelas = fieldSetFlags()[1] ? this.kd_kelas : (java.lang.CharSequence) defaultValue(fields()[1]);
        record.tanggal = fieldSetFlags()[2] ? this.tanggal : (java.lang.Integer) defaultValue(fields()[2]);
        record.wkt_mulai = fieldSetFlags()[3] ? this.wkt_mulai : (java.lang.Long) defaultValue(fields()[3]);
        record.wkt_selesai = fieldSetFlags()[4] ? this.wkt_selesai : (java.lang.Long) defaultValue(fields()[4]);
        record.ts_update = fieldSetFlags()[5] ? this.ts_update : (java.lang.Long) defaultValue(fields()[5]);
        return record;
      } catch (Exception e) {
        throw new org.apache.avro.AvroRuntimeException(e);
      }
    }
  }

  private static final org.apache.avro.io.DatumWriter
    WRITER$ = new org.apache.avro.specific.SpecificDatumWriter(SCHEMA$);

  @Override public void writeExternal(java.io.ObjectOutput out)
    throws java.io.IOException {
    WRITER$.write(this, SpecificData.getEncoder(out));
  }

  private static final org.apache.avro.io.DatumReader
    READER$ = new org.apache.avro.specific.SpecificDatumReader(SCHEMA$);

  @Override public void readExternal(java.io.ObjectInput in)
    throws java.io.IOException {
    READER$.read(this, SpecificData.getDecoder(in));
  }

}
